#! /bin/bash

blocksize=$1
threads=$2
sn=$3

export blocksize
export threads
output_dir="${blocksize}-${threads}t/"

if [ ! -d ${output_dir} ]; then
        mkdir ${output_dir}
fi

echo "====== ${blocksize}/${threads} Test Round ${sn} started ======"

echo 'noop' > /sys/block/sdb/queue/scheduler
cat /sys/block/sdb/queue/scheduler

for i in `seq 0 47`; do echo performance > /sys/devices/system/cpu/cpu${i}/cpufreq/scaling_governor; done
performance_count=$(for i in `seq 0 47`; do cat /sys/devices/system/cpu/cpu${i}/cpufreq/scaling_governor; done | grep 'performance'  | wc -l)

if [ ${performance_count} -ne 48 ]; then
	echo "something wrong with cpu setting"
else
	echo "48 cpus are running on performance state"
fi

iotop -b -o -t -d1 > ${output_dir}/iotop.$sn &
iostat -tkx 1 sdb > ${output_dir}/iostat.$sn &

echo 3 > /proc/sys/vm/drop_caches
rm -vf /export/test.img
fio randw.fio > ${output_dir}/fio.result.$sn

echo "====== ${blocksize}/${threads} Test Round ${sn} ended ======"

unset blocksize
unset threads

for pid_iotop in `ps aux | awk '/iotop/{print $2}'`; do
        kill -9 ${pid_iotop} > /dev/null 2>&1
done

for pid_iostat in `ps aux | awk '/iostat/{print $2}'`; do
        kill -9 ${pid_iostat} > /dev/null 2>&1
done
